!
! FLATBAT     FLAT     Flat field correction utility.
! Copyright (C) 1997-2004  Filip Hroch, Masaryk University, Brno, CZ
!
! $Id: flatbat.f90,v 1.2 2005/01/11 23:08:26 hroch Exp $ 
!

program flatbat
  
  implicit none

  character(len=666) :: line,sci,flatframe,outname,mask="flatbat.fits"
  character(len=15) :: format
  integer :: icit = 1
  integer :: ieql, j, n, result

  do
     read(*,'(a)',end=90) line
!     write(*,*) trim(line)     

     ieql = index(line,'=') + 1
     if( index(line,'FLATFRAME') > 0 ) then

       flatframe = line(ieql:)

     else if( index(line,'SCIFRAME') > 0 )then

       sci =  line(ieql:)

     else if( index(line,'MASK') > 0 )then

       mask =  line(ieql:)

     else if( index(line,'ICIT') > 0 )then

       read(line(ieql:),*) icit

    endif

 enddo
90 continue

 j = index(mask,"?")
 if ( j > 0 )then

    do n = 0, len_trim(mask)
       if( mask(j+n:j+n) /= '?' ) exit
    enddo
    write(format,"(A,I1.1,A,I1.1,A)") "(I",n,".",n,")"
    write(mask(j:j+n-1),format) icit

 endif

 outname = mask

! write(*,'(3a20)') sci,flatframe,outname
 call flat(sci,flatframe,outname,result)
 if( result == 0 ) then
    write(*,'(a)') trim(outname)
 else
    write(*,'(a)') ''
 endif

end program flatbat
