!
! QUICKSORT - recursive version of the QuickSort algorithm

Module MQuick

! 
! Wirth,N: Algorithm + Data Structure = Programs, Prentice-Hall, 1975
!

public QuickSort
public QuickSorti
private Trid
private Tridi

Contains

Subroutine QuickSort(A)
Real, Intent (in out) :: A(:)
Integer N

N = Size(A) 
!print '(10I5)',A

Call Trid(1,N,A)

End Subroutine

Recursive Subroutine Trid(L,R,A)
Integer,intent( in ) :: L,R
Real, intent( in out ) :: A(:)

Integer I,J
Real X,W     ! internal buffers

I = L; J = R
X = A( (L+R)/2 )

Do
  Do While ( A(I) < X )
    I = I + 1
  End Do 
  Do While ( X < A(J) )
    J = J - 1
  End Do
  If( I <= J )then
    W = A(I); A(I) = A(J); A(J) = W
    I = I + 1; J = J - 1
  EndIf
  If( I > J ) Exit
End Do

!print '(10I5)',A

If( L < J ) Call Trid(L,J,A)
If( I < R ) Call Trid(I,R,A)

End Subroutine

!--------------------------------------------------------------------------

Subroutine QuickSorti(A,n,index)
Real, Intent (in out) :: A(n)
Integer :: N, index(n)

!N = Size(A) 
!print '(10I5)',A

Call Tridi(1,N,A,index)

End Subroutine

Recursive Subroutine Tridi(L,R,A,index)
Integer,intent( in ) :: L, R 
integer :: index(:)
Real, intent( in out ) :: A(:)

Integer I,J,ii
Real X,W     ! internal buffers

I = L; J = R
X = A( (L+R)/2 )

Do
  Do While ( A(I) < X )
    I = I + 1
  End Do 
  Do While ( X < A(J) )
    J = J - 1
  End Do
  If( I <= J )then
    W = A(I); A(I) = A(J); A(J) = W
    ii = index(i); index(i) = index(j); index(j) = ii
    I = I + 1; J = J - 1
  EndIf
  If( I > J ) Exit
End Do

!print '(10I5)',A

If( L < J ) Call Tridi(L,J,A,index)
If( I < R ) Call Tridi(I,R,A,index)

End Subroutine


End Module

